<?
//--------------------------------------------------------------------------
//   PHPWeatherControl 
//   Dvelopp par Romelard Fabrice
//   Disponible sur  l'adresse : 
//            http://www.asp-php.net/scripts/asp.net/weathercontrol.php
//--------------------------------------------------------------------------

$zipcode = "FRXX0076";				// Code de la ville sur Weather.com
$partner = "XXXXXXXXXX";			// ID Partner si enregistr
$license = "XXXXXXXXXXXXXX";			// License Key si enregistr
$nbjours = "4";					// Nombre de jours  afficher

$url	 = "http://xoap.weather.com/weather/local/";	// URL to xoap.weather

$xmlsource = "$url$zipcode?cc=*&unit=s&prod=xoap&par=$partner&key=$license&dayf=$nbjours";

// ----------------------------------------------------------------------------
function conversiontemperature($farenheit) {
	if (is_numeric($farenheit)) {
//		return $farenheit;
		$temp = (int) ($farenheit - 32);
		$temp = (float) ($temp/9*5);
		return round($temp,0)."C";
	}
	else {
		return $farenheit;
	}
}

// ----------------------------------------------------------------------------
function dcomplete($date) {
 setlocale(LC_TIME, "fr");
 return ucfirst(strftime("%A %d %B %Y", $date));
}

// ----------------------------------------------------------------------------
function DateAdd($Nbjours) {

    $date_time_array = getdate();
    $hours = $date_time_array['hours'];
    $minutes = $date_time_array['minutes'];
    $seconds = $date_time_array['seconds'];
    $month = $date_time_array['mon'];
    $day = $date_time_array['mday'];
    $year = $date_time_array['year'];

    $dayAdd = $day + $Nbjours;
    $timestamp= mktime($hours,$minutes,$seconds,$month,$dayAdd,$year);
    return ($timestamp);
}

// ----------------------------------------------------------------------------
// Lecture d'un fichier XML
function lit_xml($fichier,$item,$champs) {
   // on lit le fichier
   if($chaine = @implode("",@file($fichier))) {
      // on explode sur <item>
      $tmp = preg_split("/<\/?".$item.">/",$chaine);
      // pour chaque <item>
      for($i=1;$i<sizeof($tmp)-1;$i+=2)
         // on lit les champs demands <champ>
         foreach($champs as $champ) {
            $tmp2 = preg_split("/<\/?".$champ.">/",$tmp[$i]);
            // on ajoute au tableau
            $tmp3[$i-1][] = @$tmp2[1];
         }
      // et on retourne le tableau
      return $tmp3;
   }
}

// ----------------------------------------------------------------------------
// Lecture d'un fichier XML
function lit_xml_with_attr($fichier,$item,$champs) {
   // on lit le fichier
   if($chaine = @implode("",@file($fichier))) {

//echo $chaine."<BR>";
	
      // on explode sur <item>
      $tmp = preg_split("/<\/?".$item."?>/",$chaine);
     
      // pour chaque <item>
      for($i=0;$i<sizeof($tmp)-1;$i+=1) {
      

        // on lit les champs demands <champ>
        foreach($champs as $champ) {
            $tmp2 = preg_split("/<\/?".$champ."?>/",$tmp[$i]);
            // on ajoute au tableau
            $tmp3[$i-1][] = @$tmp2[1];
        }
      }
      // et on retourne le tableau
      return $tmp3;
   }
}
// ----------------------------------------------------------------------------

// Rcupration de la date de chargement
$ladate = lit_xml($xmlsource,"dayf", array("lsup"));
foreach($ladate as $rowDate) {
	$LaDateAffiche = $rowDate[0];
}

$MeteoJours = lit_xml_with_attr($xmlsource, "part", array("icon","t","ppcp","hmid"));

// Rcupration des donnes de chaque journe
$xml = lit_xml_with_attr($xmlsource,"day",array("hi","low"));

?>
<STYLE>
tr.boxheaderGreen
{
  background-color: #669999;
}
td.boxheaderGreen {
  text-align: left;
  color: #FFFFFF;
  background-color: #669999;
}
tr.boxbodyGreenMeteo {
  color: #000000;
  background-color: #EDE9EB;
}
</STYLE>
<table cellSpacing="0" cellPadding="0" width="99%" border="0">
	<tr class="boxheaderGreen" width="100%">
		<td class="boxheaderGreen" vAlign="top" align="left" width="100%" colSpan="3">&nbsp;<B>METEO</B></td>
	</tr>
	<tr class="boxbodyGreenMeteo" width="100%">
		<td width="2" class='boxheaderGreen'>&nbsp;</td>
		<td width="100%" class="boxbodyGreenMeteo" align="center">
			<table cellspacing="0" border="0" style="border-collapse:collapse;">

<?
$compteurligne = 0;
foreach($xml as $row) {
	echo "<tr><td COLSPAN=3><font color=gray><B>";
	echo dcomplete(DateAdd($compteurligne));
	echo "</B></font></TD></TR>"
	."<TR><TD>Max: ".conversiontemperature($row[0])."<br>Min: ".conversiontemperature($row[1])."<BR>"
	."H%: ".$MeteoJours[$compteurligne*2-1][3]."</TD>";
	
	echo "<TD><font size=2 color=gray>JOUR</font><BR><IMG SRC='./Images/".$MeteoJours[$compteurligne*2-1][0].".png'BORBER=0 width=40 ALT='".$MeteoJours[$compteurligne*2-1][1]."'></TD>";
	echo "<TD><font size=2 color=gray>NUIT</font><BR><IMG SRC='./Images/".$MeteoJours[$compteurligne*2][0].".png'BORBER=0 width=40 ALT='".$MeteoJours[$compteurligne*2][1]."'></TD>";
	echo "</TR>";
	$compteurligne +=1;
}
?>
			<TR><TD colspan=3 ALIGN=CENTER><br><a href="http://www.weather.com/?prod=xoap&par=1008415171" target="_blank"><IMG src="./Images/TWClogo_32px.png" border=0></a></TD></TR>
			</table>
		</td>
		<td width="2" class='boxheaderGreen'>&nbsp;</td>
	</tr>
	<tr height="2" width="100%" class="boxheaderGreen">
		<td height="2" width="100%" colspan="3" class='boxheaderGreen'></td>
	</tr>
</table>




